//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 DodgerBlue
#property indicator_color2 Orange
#property indicator_color3 LimeGreen
#property indicator_color4 Silver
#property indicator_color5 Silver
#property indicator_color6 Orange
#property indicator_color7 Orange
#property indicator_color8 Tan
#property indicator_level1 100

#property indicator_levelcolor Silver  

//
//
//
//
//

extern string TimeFrame                 = "Current time frame";
extern int    WprPeriod                 = 32;
extern int    MaPeriod                  = 8 ;
extern int    Smooth                    = 10;
extern bool   drawDivergences           = true;
extern bool   divergenceOnValuesVisible = true;
extern bool   divergenceOnChartVisible  = false;
extern color  divergenceBullishColor    = LimeGreen;
extern color  divergenceBearishColor    = Orange;
extern string drawLinesIdentificator    = "Wpr ma diverge1";
extern string ___                       = "Divergence Alerts";
extern bool   divergenceAlert           = true;
extern bool   divergenceAlertsMessage   = true;
extern bool   divergenceAlertsSound     = true;
extern bool   divergenceAlertsNotify    = false;
extern bool   divergenceAlertsEmail     = false;
extern string divergenceAlertsSoundName = "alert1.wav";
extern int    arrowSize                 = 1; 
extern int    WprLineWidth              = 2;
extern int    MaLineWidth               = 1;
extern bool   Interpolate               = true;

double bullishDivergence[];
double bearishDivergence[];
double WprUp[];
double WprCa[];
double WprCb[];
double WprDa[];
double WprDb[];
double Ma[];
double mainTrend[];
double trend[];
double pricesh[];
double pricesl[];

//
//
//
//
//

string shortName;
string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;
string labelNames;
double pipMultiplier = 1;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(12);
   SetIndexBuffer(0,bullishDivergence); SetIndexStyle(0,DRAW_ARROW,0,arrowSize); SetIndexArrow(0,233);
   SetIndexBuffer(1,bearishDivergence); SetIndexStyle(1,DRAW_ARROW,0,arrowSize); SetIndexArrow(1,234);  
   SetIndexBuffer(2,WprUp);
   SetIndexBuffer(3,WprCa);
   SetIndexBuffer(4,WprCb);
   SetIndexBuffer(5,WprDa);
   SetIndexBuffer(6,WprDb);
   SetIndexBuffer(7,Ma);
   SetIndexBuffer(8,trend);
   SetIndexBuffer(9,mainTrend);
   SetIndexBuffer(10,pricesh);
   SetIndexBuffer(11,pricesl);
   
   for (int i=2; i<7; i++) SetIndexStyle(i,EMPTY,EMPTY,WprLineWidth);
                           SetIndexStyle(i,EMPTY,EMPTY,MaLineWidth);

   //
   //
   //
   //
   //

      indicatorFileName = WindowExpertName();
      timeFrame         = stringToTimeFrame(TimeFrame);
      shortName         = timeFrameToString(timeFrame)+" wpr ma ("+WprPeriod+","+MaPeriod+")";
      labelNames        = "Wpr_DivergenceLine "+drawLinesIdentificator+":";
      IndicatorShortName(shortName);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   return(0); 
}   
int deinit()
{
   int length=StringLen(labelNames);
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if(StringSubstr(name,0,length) == labelNames)  ObjectDelete(name);   
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { bullishDivergence[0] = limit+1; return(0); }
           if (Digits==3 || Digits==5) 
                pipMultiplier = 10;
           else pipMultiplier = 1; 

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      if (mainTrend[limit] == 0) CleanPoint(limit,WprCa,WprCb);
      if (mainTrend[limit] <  0) CleanPoint(limit,WprDa,WprDb);
      for(int i=limit; i>=0; i--)
      {
         WprCa[i] = EMPTY_VALUE;
         WprCb[i] = EMPTY_VALUE;
         WprDa[i] = EMPTY_VALUE;
         WprDb[i] = EMPTY_VALUE;
         double prices[3];
            prices[0] = iSsm(High[i] ,Smooth,i,0);
            prices[1] = iSsm(Low[i]  ,Smooth,i,1);
            prices[2] = iSsm(Close[i],Smooth,i,2);
               ArraySort(prices);
                  pricesh[i] = prices[2];
                  pricesl[i] = prices[0];
            double hh=pricesh[ArrayMaximum(pricesh,WprPeriod,i)];
            double ll=pricesl[ArrayMinimum(pricesl,WprPeriod,i)];
            double wpr = 0;
            if(hh!=ll) wpr = 100.0*(prices[1]-ll)/(hh-ll);
               WprUp[i] = wpr;
               Ma[i]    = WprUp[i];
               for (int l=1; l<MaPeriod; l++) Ma[i] += WprUp[i+l]; Ma[i] /= MaPeriod;

         //
         //
         //
         //
         //
         
         trend[i]     = trend[i+1];
            if (Ma[i]<WprUp[i]) trend[i] =  1;
            if (Ma[i]>WprUp[i]) trend[i] = -1;
         mainTrend[i] = trend[i]+trend[i+1];
            if (mainTrend[i] == 0) PlotPoint(i,WprCa,WprCb,WprUp);
            if (mainTrend[i] <  0) PlotPoint(i,WprDa,WprDb,WprUp); 
            if (drawDivergences)
            {
              CatchBullishDivergence(i);
              CatchBearishDivergence(i);
            }         
      }
      return(0);
   }

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (mainTrend[limit] == 0) CleanPoint(limit,WprCa,WprCb);
   if (mainTrend[limit] <  0) CleanPoint(limit,WprDa,WprDb);
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         mainTrend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,Smooth,drawDivergences,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,drawLinesIdentificator,"",divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsNotify,divergenceAlertsEmail,divergenceAlertsSoundName,9,y);
         Ma[i]        = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,Smooth,drawDivergences,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,drawLinesIdentificator,"",divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsNotify,divergenceAlertsEmail,divergenceAlertsSoundName,7,y);
         WprUp[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,Smooth,drawDivergences,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,drawLinesIdentificator,"",divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsNotify,divergenceAlertsEmail,divergenceAlertsSoundName,2,y);
         WprCa[i]     = EMPTY_VALUE;
         WprCb[i]     = EMPTY_VALUE;
         WprDa[i]     = EMPTY_VALUE;
         WprDb[i]     = EMPTY_VALUE;
         bullishDivergence[i] = EMPTY_VALUE;
         bearishDivergence[i] = EMPTY_VALUE;
             
         int firstBar = iBarShift(NULL,0,iTime(NULL,timeFrame,y));
         if (i==firstBar)
         {
            bullishDivergence[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,Smooth,drawDivergences,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,drawLinesIdentificator,"",divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsNotify,divergenceAlertsEmail,divergenceAlertsSoundName,0,y);
            bearishDivergence[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",WprPeriod,MaPeriod,Smooth,drawDivergences,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,drawLinesIdentificator,"",divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsNotify,divergenceAlertsEmail,divergenceAlertsSoundName,1,y);
         }

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               WprUp[i+k] = WprUp[i] + (WprUp[i+n]-WprUp[i])*k/n;
               Ma[i+k]    = Ma[i]    + (Ma[i+n]   -Ma[i]   )*k/n;
            }
   }
   for (i=limit;i>=0;i--)
   {
      if (mainTrend[i] == 0) PlotPoint(i,WprCa,WprCb,WprUp);
      if (mainTrend[i] <  0) PlotPoint(i,WprDa,WprDb,WprUp); 
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-2) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
               { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else        { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288
double workSsm[][6];
#define _tprice  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      int s = instanceNo*2;   
      i = Bars-i-1;
          workSsm[i][s+_tprice] = price;
          if (i<2)
               workSsm[i][s+_ssm] = price;
          else workSsm[i][s+_ssm]  = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                                     workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                                + 
                                     workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm]; 
   return(workSsm[i][s+_ssm]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CatchBullishDivergence(int shift)
{
   shift++;
         bullishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"l"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"l"+"os" + DoubleToStr(Time[shift],0));            
   if(!IsIndicatorLow(shift)) return;  

   //
   //
   //
   //
   //
      
   int currentLow = shift;
   int lastLow    = GetIndicatorLastLow(shift+1);
    
   if(WprUp[currentLow] > WprUp[lastLow] && Low[currentLow] < Low[lastLow])
   {
      bullishDivergence[currentLow] = WprUp[currentLow]-Point*pipMultiplier;
      if(divergenceOnChartVisible)  DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],    divergenceBullishColor,STYLE_SOLID);
      if(divergenceOnValuesVisible) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],WprUp[currentLow],WprUp[lastLow],divergenceBullishColor,STYLE_SOLID);
      if(divergenceAlert)           DisplayAlert("Classical bullish divergence",currentLow); 
   }
     
   //
   //
   //
   //
   //
        
   if(WprUp[currentLow] < WprUp[lastLow] && Low[currentLow] > Low[lastLow])
   {
      bullishDivergence[currentLow] = WprUp[currentLow]-Point*pipMultiplier;
      if(divergenceOnChartVisible)  DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],    divergenceBullishColor,STYLE_DOT);
      if(divergenceOnValuesVisible) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],WprUp[currentLow],WprUp[lastLow],divergenceBullishColor,STYLE_DOT);
      if(divergenceAlert)           DisplayAlert("Reverse bullish divergence",currentLow); 
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CatchBearishDivergence(int shift)
{
   shift++; 
         bearishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"h"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"h"+"os" + DoubleToStr(Time[shift],0));            
   if(IsIndicatorPeak(shift) == false) return;
   
   //
   //
   //
   //
   //
   
   int currentPeak = shift;
   int lastPeak    = GetIndicatorLastPeak(shift+1);
      
   if(WprUp[currentPeak] < WprUp[lastPeak] && High[currentPeak]>High[lastPeak])
   {
       bearishDivergence[currentPeak] = WprUp[currentPeak]+Point*pipMultiplier;
       if (divergenceOnChartVisible)  DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],  divergenceBearishColor,STYLE_SOLID);
       if (divergenceOnValuesVisible) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],WprUp[currentPeak],WprUp[lastPeak],divergenceBearishColor,STYLE_SOLID);
       if (divergenceAlert)           DisplayAlert("Classical bearish divergence",currentPeak); 
   }
   
   //
   //
   //
   //
   //

   if(WprUp[currentPeak] > WprUp[lastPeak] && High[currentPeak] < High[lastPeak])
   {
      bearishDivergence[currentPeak] = WprUp[currentPeak]+Point*pipMultiplier;
      if (divergenceOnChartVisible ) DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],  divergenceBearishColor,STYLE_DOT);
      if (divergenceOnValuesVisible) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],WprUp[currentPeak],WprUp[lastPeak],divergenceBearishColor,STYLE_DOT);
      if (divergenceAlert)           DisplayAlert("Reverse bearish divergence",currentPeak);
   }   
}

//
//
//
//
//

bool IsIndicatorPeak(int shift)
{
   if(WprUp[shift] >= WprUp[shift+1] && WprUp[shift] > WprUp[shift+2] && WprUp[shift] > WprUp[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

bool IsIndicatorLow(int shift)
{
   if(WprUp[shift] <= WprUp[shift+1] && WprUp[shift] < WprUp[shift+2] && WprUp[shift] < WprUp[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int GetIndicatorLastPeak(int shift)
{
    for(int i = shift+5; i < Bars; i++)
    {
       if(WprUp[i] >= WprUp[i+1] && WprUp[i] > WprUp[i+2] && WprUp[i] >= WprUp[i-1] && WprUp[i] > WprUp[i-2])
         return(i);
    }
return(-1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int GetIndicatorLastLow(int shift)
{
    for (int i = shift+5; i < Bars; i++)
    {
       if (WprUp[i] <= WprUp[i+1] && WprUp[i] < WprUp[i+2] && WprUp[i] <= WprUp[i-1] && WprUp[i] < WprUp[i-2])
         return(i);
}
     
return(-1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
    string label = labelNames+first+"os"+DoubleToStr(t1,0);
    
      ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//
//
//
//
//

void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   int indicatorWindow = WindowFind(shortName);
   if (indicatorWindow < 0) return;
   string label = labelNames+first+DoubleToStr(t1,0);
   
      ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//
//
//
//
//

void DisplayAlert(string doWhat, int shift)
{
    string dmessage;
    static datetime lastAlertTime;
    if(shift <= 2 && Time[0] != lastAlertTime)
    {
      dmessage =  StringConcatenate(Symbol()," at ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Wpr ma ",doWhat);
          if (divergenceAlertsMessage) Alert(dmessage);
          if (divergenceAlertsEmail)   SendMail(StringConcatenate(Symbol()," Wpr ma "),dmessage);
          if (divergenceAlertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Wpr ma " +" "+dmessage));
          if (divergenceAlertsSound)   PlaySound(divergenceAlertsSoundName); 
          lastAlertTime = Time[0];
    }
}
